--common.lua
--common functions of site analysis

local M = {}	--public interface

function M.get_urlsource(inputURL, body)
    local http = require("socket.http")
    local body, code, headers, status = http.request(inputURL, body)
    --多试几次 防止中断
    for i=1,10 do
        if not body then
            print("http error : " .. code)
            body, code, headers, status = http.request(inputURL, body)
        else
            break
        end
        --os.execute("sleep 0.05")
    end
    if not body then
        return nil, "http error : " .. code
    end
    
    return body, code, headers, status
end

function M.get_urlsourcelocation(inputURL, body)
	local http = require("socket.http")
	local body, code, headers, status = http.requestlocation(inputURL, body)
    --多试几次 防止中断
    for i=1,5 do
        if not body then
            print("http error : " .. code)
            body, code, headers, status = http.requestlocation(inputURL, body)
        else
            break
        end
        --os.execute("sleep 0.05")
    end
	if not body then
		return nil, "http error : " .. code
	end
	
	return body, code, headers, status
end

function M.unescape (s)
      local s = string.gsub(s, "%+", " ")
      s = string.gsub(s, "%%(%x%x)", function (h)
            return string.char(tonumber(h, 16))
          end)
      return s
end

function M.secondsToHMS(sec)
	if not sec then sec = "0" end
	local nHours, nMins , nSecs = 0,0,0
	local nSeconds = tonumber(sec)
	if nSeconds == 0 then
		return "00:00:00"
	else
		nHours = string.format("%02.f", math.floor(nSeconds/3600));
		nMins = string.format("%02.f", math.floor(nSeconds/60 - (nHours*60)));
		nSecs = string.format("%02.f", math.floor(nSeconds - nHours*3600 - nMins *60));
		return nHours .. ":" .. nMins .. ":" .. nSecs
	end
end

function M.mLuaLog(formatstring,...)
	print(os.date("%D %r") .. "		" .. "Lua:" .. string.format(formatstring, ...))
end

-----========used for test=======-----
function M.stringWithFile(name)
		io = require("io")
		f = io.open(name)
		str = f:read("*a")
		f:close()
		return str
end

return M
